Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

Main Page | Modules | Namespace List | Class Hierarchy | Class List | Namespace Members | Class Members | Related Pages

# openvrml::mfvec3f Class Reference
[Field Values]

Inheritance diagram for openvrml::mfvec3f:

[legend]
List of all members.

## Detailed Description

A 3-component vector array node field value.

Model of
  FieldValue

## Public Types

typedef std::vector< vec3f > | value_type
| Type of value.

## Public Member Functions

| mfvec3f (std::vector< vec3f >::size_type n=0, const vec3f &value=vec3f()) throw (std::bad_alloc)
| Construct.
| mfvec3f (const std::vector< vec3f > &value) throw (std::bad_alloc)
| Construct.
template<typename InputIterator>
| mfvec3f (InputIterator first, InputIterator last)
| Create an mfvec3f with a copy of a range.
virtual | ~mfvec3f () throw ()
| Destroy.
virtual std::auto_ptr< field_value > | clone () const throw (std::bad_alloc)
| Virtual copy constructor.
virtual field_value & | assign (const field_value &value) throw (std::bad_cast, std::bad_alloc)
| Virtual assignment.
virtual type_id | type () const throw ()
| Get the field_value::type_id associated with this class.

## Public Attributes

std::vector< vec3f > | value
| 3-component vector values.

## Private Member Functions

virtual void | print (std::ostream &) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const mfvec3f &lhs, const mfvec3f &rhs) throw()
| Compare for equality.
bool | operator!= (const mfvec3f &lhs, const mfvec3f &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfvec3f &a, openvrml::mfvec3f &b)
| Swap the values of `a` and `b`.

## Member Typedef Documentation

openvrml::mfvec3f::value_type

| Type of value.

## Constructor & Destructor Documentation

openvrml::mfvec3f::mfvec3f | ( | std::vector< vec3f >::size_type | n = `0`,
|  | const vec3f & | value = `vec3f()`
| ) | throw (std::bad_alloc)`[explicit]`

Construct.

Creates an mfvec3f with `n` copies of `value`.

Parameters:

  | n | the number elements in mfvec3f::value.
  | value | used to initialize mfvec3f::value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Postcondition:
  `mfvec3f::value.size()` is `n`. Every element in mfvec3f::value is a copy of `value`.

openvrml::mfvec3f::mfvec3f | ( | const std::vector< vec3f > & | value | ) | throw (std::bad_alloc)`[explicit]`

Construct.

Parameters:

  | value | initial value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

template<typename InputIterator>
openvrml::mfvec3f::mfvec3f | ( | InputIterator | first,
|  | InputIterator | last
| ) |

Create an mfvec3f with a copy of a range.

Creates an mfvec3f with a value that is a copy of the range [`first`, `last`).

Parameters:

  | first | an iterator pointing to the beginning of the range.
  | last | an iterator pointing one past the end of the range.

openvrml::mfvec3f::~mfvec3f | ( |  | ) | throw ()`[virtual]`

| Destroy. Each of the mfvec3f's value elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

std::auto_ptr< field_value > openvrml::mfvec3f::clone | ( |  | ) | const throw (std::bad_alloc)`[virtual]`

Virtual copy constructor.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

field_value & openvrml::mfvec3f::assign | ( | const field_value & | value | ) | throw (std::bad_cast, std::bad_alloc)`[virtual]`

Virtual assignment.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an mfvec3f object.
  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

field_value::type_id openvrml::mfvec3f::type | ( |  | ) | const throw ()`[virtual]`

Get the field_value::type_id associated with this class.

Returns:
  `field_value::mfvec3f_id`.

Implements openvrml::field_value.

void openvrml::mfvec3f::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfvec3f & | lhs,
|  | const mfvec3f & | rhs
| ) | throw()`[related]`

Compare for equality.

Parameters:

  | lhs | left-hand operand.
  | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfvec3f & | lhs,
|  | const mfvec3f & | rhs
| ) | throw()`[related]`

Compare for inequality.

Parameters:

  | lhs | left-hand operand.
  | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfvec3f & | a,
|  | openvrml::mfvec3f & | b
| ) | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  | a |
  | b |

## Member Data Documentation

std::vector< vec3f > openvrml::mfvec3f::value

| 3-component vector values.